Ext.define('DSS.editor.ActivityStateEditorPart', {
	extend : 'DSS.component.Base',
	mixins : {
		observable : 'Ext.util.Observable'
	},
	getHeight : function() {
		return 0;
	},
	initStores : function () {		
		if (Ext.data.StoreManager.lookup('activitySetTrigger') == null) {
            Ext.create('Ext.data.Store', {
                storeId : 'activitySetTrigger',
                fields : [ 'number','value'],
                proxy : {
                    type : 'memory',
                    reader : {
                        type : 'json',
                        root : 'items'
                    }
                }
            });
        }
		Ext.data.StoreManager.lookup('activitySetTrigger').removeAll();
		if (Ext.data.StoreManager.lookup('activityResetTrigger') == null) {
            Ext.create('Ext.data.Store', {
                storeId : 'activityResetTrigger',
                fields : [ 'number','value'],
                proxy : {
                    type : 'memory',
                    reader : {
                        type : 'json',
                        root : 'items'
                    }
                }
            });
        }
		Ext.data.StoreManager.lookup('activityResetTrigger').removeAll();
	},
	startEditSetTrigger:function(iIndex) {
		this.setTriggerPanelEditor.expand();
		this.selectedSetId=-1;
		if (this.setTriggerPanelGrid.getSelectionModel().getSelection().length==0)
			iIndex=-1;
    	if (iIndex==-1) {
    		this.setTriggerEditor.reset();
    	} else {
	    	var baseRecord=this.setTriggerPanelGrid.getSelectionModel().getSelection()[0];
			if ((baseRecord.get('value')==null) || (baseRecord.get('value')==''))
				this.setTriggerEditor.reset();
			else {
				this.selectedSetId=baseRecord.get('number');	    		
				this.setTriggerEditor.setValue(baseRecord.get('value'));
			}
    	}
    	this.setTriggerEditor.setHeight(224);
	},
	startEditResetTrigger:function(iIndex) {
		this.resetTriggerPanelEditor.expand();
		this.selectedResetId=-1;
		if (this.resetTriggerPanelGrid.getSelectionModel().getSelection().length==0)
			iIndex=-1;
    	if (iIndex==-1) {
    		this.resetTriggerEditor.reset();
    	} else {
	    	var baseRecord=this.resetTriggerPanelGrid.getSelectionModel().getSelection()[0];
			if ((baseRecord.get('value')==null) || (baseRecord.get('value')==''))
				this.resetTriggerEditor.reset();
			else {
				this.selectedResetId=baseRecord.get('number');	    		
				this.resetTriggerEditor.setValue(baseRecord.get('value'));
			}
    	}
    	this.resetTriggerEditor.setHeight(224);
	},
	selectedSetId:-1,
	selectedResetId:-1,
	takeOverValue : function () {
		if (!this.setTriggerEditor.isValid())
			return;
		if (this.setTriggerEditor.getHeight()<10)
			return;
		var value=this.setTriggerEditor.getValue();
		if (this.selectedSetId==-1){
			this.selectedSetId=((new Date()).getTime());
			Ext.data.StoreManager.lookup('activitySetTrigger').add({number:this.selectedSetId,value:value});
		} else {
			var record=Ext.data.StoreManager.lookup('activitySetTrigger').findRecord('number',this.selectedSetId,0,false,true,true);
			if (record!=null) {
				record.set("value",value);
				record.commit();
			}
		}
		this.setTriggerPanelGrid.getView().refresh();
	},
	takeOverReValue : function () {
		if (!this.resetTriggerEditor.isValid())
			return;
		if (this.resetTriggerEditor.getHeight()<10)
			return;
		var value=this.resetTriggerEditor.getValue();
		if (this.selectedResetId==-1){
			this.selectedResetId=((new Date()).getTime());
			Ext.data.StoreManager.lookup('activityResetTrigger').add({number:this.selectedResetId,value:value});
		} else {
			var record=Ext.data.StoreManager.lookup('activityResetTrigger').findRecord('number',this.selectedResetId,0,false,true,true);
			if (record!=null) {
				record.set("value",value);
				record.commit();
			}
		}
		this.resetTriggerPanelGrid.getView().refresh();
	},
	buttonEditSetTrigger: function() {
    	if (this.setTriggerPanelEditor.getCollapsed())
        	this.startEditSetTrigger();
    	else {
    		this.takeOverValue();
        	this.setTriggerPanelEditor.collapse();
    	}
	},
	buttonEditResetTrigger: function() {
    	if (this.resetTriggerPanelEditor.getCollapsed())
        	this.startEdiResetTrigger();
    	else {
    		this.takeOverReValue();
        	this.resetTriggerPanelEditor.collapse();
    	}
	},
	constructor : function(config) {		
		var me=this;
    	this.initStores();
    	
		this.oButtonNewSetTrigger = Ext.create('Ext.button.Button', {
            iconCls : 'icon-edit-action',
            text : _('Add trigger'),
            disabled : false,
            handler : function() {         
            	if (me.setTriggerPanelEditor.getCollapsed())
            		me.startEditSetTrigger(-1);
            	else {
            		me.takeOverValue();
                	me.setTriggerPanelEditor.collapse();
            	}
            }
        });
		this.oButtonNewResetTrigger = Ext.create('Ext.button.Button', {
            iconCls : 'icon-edit-action',
            text : _('Add trigger'),
            disabled : false,
            handler : function() {         
            	if (me.resetTriggerPanelEditor.getCollapsed())
            		me.startEditResetTrigger(-1);
            	else {
            		me.takeOverReValue();
                	me.resetTriggerPanelEditor.collapse();
            	}
            }
        });

		this.oButtonEditSetTrigger = Ext.create('Ext.button.Button', {
            iconCls : 'icon-edit-action',
            text : _('Edit trigger'),
            disabled : true,
            handler : function() {
            	me.buttonEditSetTrigger();
            }
        });
		this.oButtonEditResetTrigger = Ext.create('Ext.button.Button', {
            iconCls : 'icon-edit-action',
            text : _('Edit trigger'),
            disabled : true,
            handler : function() {
            	me.buttonEditResetTrigger();
            }
        });
		
		this.oButtonDeleteSetTrigger = Ext.create('Ext.button.Button', {
            iconCls : 'icon-delete-action',
            tooltip:  _('Delete trigger'),
            disabled : true,
            handler : function() {
            	if (me.setTriggerPanelGrid.getSelectionModel().getSelection().length==0)
            		return;
            	var baseRecord=me.setTriggerPanelGrid.getSelectionModel().getSelection()[0];
            	Ext.data.StoreManager.lookup('activitySetTrigger').remove(baseRecord);
            }
        });		
		this.oButtonDeleteResetTrigger = Ext.create('Ext.button.Button', {
            iconCls : 'icon-delete-action',
            tooltip:  _('Delete trigger'),
            disabled : true,
            handler : function() {
            	if (me.resetTriggerPanelGrid.getSelectionModel().getSelection().length==0)
            		return;
            	var baseRecord=me.resetTriggerPanelGrid.getSelectionModel().getSelection()[0];
            	Ext.data.StoreManager.lookup('activityResetTrigger').remove(baseRecord);
            }
        });
		
		
		this.setTriggerPanelGrid = Ext.create('Ext.grid.Panel', {
            enableColumnHide : false,
            enableColumnMove : false,
            border : '0',
            region : 'center',
            store : Ext.data.StoreManager.lookup('activitySetTrigger'),
            hideHeaders : true,
            overflowX:'hidden',                
            width: 736,
            height : 276,
       		viewConfig : {
                stripeRows : true
            },
            columns : [{
                dataIndex : 'value',
                sortable : false,
                hideable : false,
                flex:1,
                xtype: 'triggercolumn'}],
            tbar : [ this.oButtonNewSetTrigger, this.oButtonEditSetTrigger,  '->', this.oButtonDeleteSetTrigger ]
        });
		this.setTriggerPanelGrid.isFieldActive=function(){return true;};

		
		this.resetTriggerPanelGrid = Ext.create('Ext.grid.Panel', {
            enableColumnHide : false,
            enableColumnMove : false,
            border : '0',
            region : 'center',
            store : Ext.data.StoreManager.lookup('activityResetTrigger'),
            hideHeaders : true,
            overflowX:'hidden',                
            width: 736,
            height : 276,
       		viewConfig : {
                stripeRows : true
            },
            columns : [{
                dataIndex : 'value',
                sortable : false,
                hideable : false,
                flex:1,
                xtype: 'triggercolumn'}],
            tbar : [ this.oButtonNewResetTrigger, this.oButtonEditResetTrigger,  '->', this.oButtonDeleteResetTrigger ]
        });
		this.resetTriggerPanelGrid.isFieldActive=function(){return true;};
		
		this.setTriggerPanelGrid.on("selectionchange",function () {
			if (me.setTriggerPanelGrid.getSelectionModel().getSelection().length>0) {
				me.oButtonEditSetTrigger.setDisabled(false);
				me.oButtonDeleteSetTrigger.setDisabled(false);
			} else {
				me.oButtonEditSetTrigger.setDisabled(true);
				me.oButtonDeleteSetTrigger.setDisabled(true);
			}
		});
        this.setTriggerPanelGrid.on("itemdblclick",function () {
        	me.startEditSetTrigger();
		});
        
		this.resetTriggerPanelGrid.on("selectionchange",function () {
			if (me.resetTriggerPanelGrid.getSelectionModel().getSelection().length>0) {
				me.oButtonEditResetTrigger.setDisabled(false);
				me.oButtonDeleteResetTrigger.setDisabled(false);
			} else {
				me.oButtonEditResetTrigger.setDisabled(true);
				me.oButtonDeleteResetTrigger.setDisabled(true);
			}
		});
        this.resetTriggerPanelGrid.on("itemdblclick",function () {
        	me.startEditResetTrigger();
		});
        
        
		this.setTriggerEditor=Ext.create('DSS.component.TriggerConfigurator',{
			border : '0',
       		height : 226,
       		myID:'elf',
            autoScroll : true,
            animCollapse : true,
            width: 732
   		});
		this.resetTriggerEditor=Ext.create('DSS.component.TriggerConfigurator',{
			border : '0',
       		height : 226,
       		myID:'reelf',
            autoScroll : true,
            animCollapse : true,
            width: 732
   		});

		this.setTriggerEditor.on('valueDoubleClicked',function () {
    		me.takeOverValue();
        	me.setTriggerPanelEditor.collapse();
		});
		this.resetTriggerEditor.on('valueDoubleClicked',function () {
    		me.takeOverReValue();
        	me.resetTriggerPanelEditor.collapse();
		});
		
		this.setTriggerPanelEditor=Ext.create('Ext.panel.Panel', {		
			border : '0',
			autoScroll : true,
            animCollapse : true,           
			title:' ',
            header:false,
			region : 'south',
			items : [ this.setTriggerEditor ],
            collapsible : true,
            collapsed : true,
			height: 226,
			width:734,
			hideCollapseTool:true,
			layout: {
				type: 'fit'
			}
		});		
		this.resetTriggerPanelEditor=Ext.create('Ext.panel.Panel', {		
			border : '0',
			autoScroll : true,
            animCollapse : true,           
			title:' ',
            header:false,
			region : 'south',
			items : [ this.resetTriggerEditor ],
            collapsible : true,
            collapsed : true,
			height: 226,
			width:734,
			hideCollapseTool:true,
			layout: {
				type: 'fit'
			}
		});
		
		this.setTriggerPanel=Ext.create('Ext.panel.Panel', {		
			title: _('Trigger to set State'),
			items : [ this.setTriggerPanelGrid,this.setTriggerPanelEditor ],
			height: 280,
			width:738,
			layout: {
				type: 'border'
			}
		});
		this.resetTriggerPanel=Ext.create('Ext.panel.Panel', {
			title: _('Trigger to reset State'),
			items : [ this.resetTriggerPanelGrid,this.resetTriggerPanelEditor  ],
			height: 280,
			width:738,
			layout: {
				type: 'border'
			}
		});
  
		
		this.setRetriggeringMinute=Ext.create('Ext.form.field.Number', {
            allowBlank : false,
            blankText : _('This field is required'),
            invalidText : _('The value in this field is invalid'),
            fieldLabel:_('Set state after a period of'),
            width : 320,
            labelWidth:270,
            step : 1,
            value : 0,
            minValue : 0,
            maxValue : 59,
            margin: "8 0 0 5",
            autoStripChars:true,
            decimalPrecision:0
        });
		this.setRetriggeringSeconds=Ext.create('Ext.form.field.Number', {
            allowBlank : false,
            blankText : _('This field is required'),
            invalidText : _('The value in this field is invalid'),
            width : 44,
            step : 1,
            value : 0,
            minValue : 0,
            maxValue : 59,
            margin: "8 0 0 0",
            autoStripChars:true,
            decimalPrecision:0
        });
		
		this.resetRetriggeringMinute=Ext.create('Ext.form.field.Number', {
            allowBlank : false,
            blankText : _('This field is required'),
            invalidText : _('The value in this field is invalid'),
            fieldLabel:_('Reset state after a period of'),
            width : 320,
            labelWidth:270,
            step : 1,
            value : 0,
            minValue : 0,
            maxValue : 59,
            margin: "8 0 0 5",
            autoStripChars:true,
            decimalPrecision:0
        });
		this.resetRetriggeringSeconds=Ext.create('Ext.form.field.Number', {
            allowBlank : false,
            blankText : _('This field is required'),
            invalidText : _('The value in this field is invalid'),
            width : 44,
            step : 1,
            value : 0,
            minValue : 0,
            maxValue : 59,
            margin: "8 0 0 0",
            autoStripChars:true,
            decimalPrecision:0
        });
		
		this.retriggerPanel=Ext.create('Ext.panel.Panel', {
			border:0,
			items : [this.deviceUnready, 
			         this.setRetriggeringMinute,	         
			         this.setRetriggeringSeconds,
			         {xtype:'displayfield',value:_('mm:ss'), margin: "8 0 0 5", width:50},
			         {xtype:'displayfield',value:_('if no other trigger has happened'), margin: "8 0 0 5", width:370}, 
			         this.resetRetriggeringMinute,	         
			         this.resetRetriggeringSeconds,
			         {xtype:'displayfield',value:_('mm:ss'), margin: "8 0 0 5", width:50},
			         {xtype:'displayfield',value:_('if no other trigger has happened'), margin: "8 0 0 5", width:370}
			         ],
			height: 80,
			width:738,
			layout: {
				type:'table',
    			columns:4
			}
		});
		
		this.baseTab=Ext.create('Ext.tab.Panel', {
        	border: 0,
			height: 280,
            cls:'generalTab',
            items : [ this.setTriggerPanel,
                      this.resetTriggerPanel]
        });
		
        Ext.apply(this, {
        	border: 0,
  			items : [ this.baseTab,this.retriggerPanel ],
  			height: 350,
  			width:740,
  			layout: {
  				type: 'vbox'
  			}
  		});
  	
  		this.callParent(arguments);
    	
	},
	reset : function() {
		this.initStores();
		this.setTriggerPanel.setTitle( _('Trigger to set State'));
		this.resetTriggerPanel.setTitle( _('Trigger to reset State'));			
		this.setTriggerEditor.reset();
		this.resetTriggerEditor.reset();
		this.setRetriggeringMinute.setValue(0);
		this.setRetriggeringSeconds.setValue(0);
		this.resetRetriggeringMinute.setValue(0);
		this.resetRetriggeringSeconds.setValue(0);
	},
	isValid : function() {
		if (this.isHidden())
			return true;
		this.takeOverValue();
		this.takeOverReValue();
		var fValid=true;
		if (Ext.data.StoreManager.lookup('activitySetTrigger').count()==0) {
			fValid=false;
			this.setTriggerPanel.setTitle('<span style="color:#ff0000;">' + _('Trigger to set State') + '</span>');
		} else {
			this.setTriggerPanel.setTitle( _('Trigger to set State'));
		}
		if (Ext.data.StoreManager.lookup('activityResetTrigger').count()==0) {
			fValid=false;
			this.resetTriggerPanel.setTitle('<span style="color:#ff0000;">' + _('Trigger to reset State') + '</span>');
		} else {
			this.resetTriggerPanel.setTitle( _('Trigger to reset State'));			
		}
			
		return ((Ext.data.StoreManager.lookup('activitySetTrigger').count()>0) && 
				(Ext.data.StoreManager.lookup('activityResetTrigger').count()>0));
	},
	setValue : function(oValue) {
		this.reset();
		var iNewIndex=(new Date()).getTime()-1;
		if (oValue!=null) {
			if (oValue.setTrigger!=null) 
				for (var iIndex=0;iIndex<oValue.setTrigger.length;iIndex++) {
					iNewIndex--;
					Ext.data.StoreManager.lookup('activitySetTrigger').add({number:iNewIndex,value:[oValue.setTrigger[iIndex]]});
				}
			if (oValue.resetTrigger!=null) 
				for (var iIndex=0;iIndex<oValue.resetTrigger.length;iIndex++) {
					iNewIndex--;
					Ext.data.StoreManager.lookup('activityResetTrigger').add({number:iNewIndex,value:[oValue.resetTrigger[iIndex]]});
				}
		}
		this.setTriggerPanelGrid.getView().refresh();
		this.resetTriggerPanelGrid.getView().refresh();
        this.setRetriggeringSeconds.setValue(oValue.setRetriggeringLag%60);
        this.resetRetriggeringSeconds.setValue(oValue.resetRetriggeringLag%60);
        this.setRetriggeringMinute.setValue(Math.floor(oValue.setRetriggeringLag/60));
        this.resetRetriggeringMinute.setValue(Math.floor(oValue.resetRetriggeringLag/60));
	},
	getValue : function() {
		if (this.isHidden())
			return {};
		var setTrigger=[];
		var resetTrigger=[];
		for (var iIndex=0;iIndex<Ext.data.StoreManager.lookup('activitySetTrigger').count();iIndex++) {
			setTrigger=setTrigger.concat(Ext.data.StoreManager.lookup('activitySetTrigger').getAt(iIndex).get("value"));
		}
		for (var iIndex=0;iIndex<Ext.data.StoreManager.lookup('activityResetTrigger').count();iIndex++) {
			resetTrigger=resetTrigger.concat(Ext.data.StoreManager.lookup('activityResetTrigger').getAt(iIndex).get("value"));
		}
		return {
			setTrigger:setTrigger,
			resetTrigger:resetTrigger,
			setRetriggeringLag:this.setRetriggeringSeconds.getValue() + (this.setRetriggeringMinute.getValue()*60),
			resetRetriggeringLag:this.resetRetriggeringSeconds.getValue() + (this.resetRetriggeringMinute.getValue()*60)
		}
	}
});