
function tiltedEnabler(dsid) {
	if (document.getElementById('titled'+dsid)!=null) {
		if (document.getElementById('state'+dsid+'_0').checked) {
			document.getElementById('titled'+dsid).disabled='disabled';
			document.getElementById('text'+dsid).style='color:#aaaaaa;';
			 
		} else {
			document.getElementById('titled'+dsid).disabled='';
			document.getElementById('text'+dsid).style='color:#000000;';
		}
	}
}

Ext.define('DSS.component.stateColumn', {
    extend: 'Ext.grid.column.Column',
    alias: 'widget.statecolumn',
    
    constructor: function() {
        this.callParent(arguments);
    },

    renderer : function(val, metadata, record, rowIdx, colIdx, store, view){

    	var fTilted=false;
    	var iPos=0;
    	if (val=='ignore')
    		iPos=0;
    	if (val=='open')
    		iPos=1;
    	if (val=='open-tilded') {
    		iPos=1;
    		fTilted=true;
    	}
    	if (val=='closed')
    		iPos=2;
    	if (val=='closed-tilded') {
    		iPos=2;
    		fTilted=true;
    	}
    	var sString= '<table><tr>';
    	if (iPos==0)
    		sString+= '<td><input type="radio" onchange="tiltedEnabler(\''+record.get('dSID')+'\');" id="state'+record.get('dSID')+'_0"  name="state'+record.get('dSID')+'" value="0" checked></td><td>'+_('ignore')+'</td>';
    	else
    		sString+= '<td><input type="radio" onchange="tiltedEnabler(\''+record.get('dSID')+'\');" id="state'+record.get('dSID')+'_0"  name="state'+record.get('dSID')+'" value="0"></td><td>'+_('ignore')+'</td>';
    	if (iPos==1)
    		sString+= '<td><input type="radio" onchange="tiltedEnabler(\''+record.get('dSID')+'\');" name="state'+record.get('dSID')+'" id="state'+record.get('dSID')+'_1" value="1" checked></td><td>'+_('open')+'</td>';
    	else
    		sString+= '<td><input type="radio" onchange="tiltedEnabler(\''+record.get('dSID')+'\');" name="state'+record.get('dSID')+'" id="state'+record.get('dSID')+'_1" value="1"></td><td>'+_('open')+'</td>';
    	
    	if (iPos==2)
    		sString+= '<td><input type="radio" onchange="tiltedEnabler(\''+record.get('dSID')+'\');" name="state'+record.get('dSID')+'" id="state'+record.get('dSID')+'_2" value="2" checked></td><td>'+_('closed')+'</td>';
    	else
    		sString+= '<td><input type="radio" onchange="tiltedEnabler(\''+record.get('dSID')+'\');" name="state'+record.get('dSID')+'" id="state'+record.get('dSID')+'_2" value="2"></td><td>'+_('closed')+'</td>';
    	if (record.get('type')==1) {
    		sString+= '<td></td><td></td>';    		
    	} else {
	    	if (iPos==0) {
	        	if (fTilted)
	        		sString+= '<td><input type="checkbox" disabled="disabled" id="titled'+record.get('dSID')+'" checked></td><td id="text'+record.get('dSID')+'" style="color:#aaaaaa;">'+_('tilded')+'</td>';
	        	else
	        		sString+= '<td><input type="checkbox" disabled="disabled" id="titled'+record.get('dSID')+'"></td><td id="text'+record.get('dSID')+'" style="color:#aaaaaa;">'+_('tilded')+'</td>';
	    	} else {
		    	if (fTilted)
		    		sString+= '<td><input type="checkbox" id="titled'+record.get('dSID')+'" checked></td><td id="text'+record.get('dSID')+'">'+_('tilded')+'</td>';
		    	else
		    		sString+= '<td><input type="checkbox" id="titled'+record.get('dSID')+'"></td><td id="text'+record.get('dSID')+'">'+_('tilded')+'</td>';
	    	}
    	}
    	sString+= '</tr></table>';
    	return sString;
    }
});


Ext.define('DSS.editor.WindowStateEditorPart', {
	extend : 'DSS.component.Base',
	mixins : {
		observable : 'Ext.util.Observable'
	},
	getHeight : function() {
		return 0;
	},
	filterFunc:function(oDevice) {
		if (oDevice.present==false)
			return 0;
		if (dss.staticDataModel.IsWindowHandle(oDevice))
			return 2;
		if (oDevice.binaryInputs!=null)
			if (oDevice.binaryInputs.length==1)
				if (oDevice.binaryInputs[0].type==14) {
					return 1;
				}		
		return 0;
	},
	initStores : function () {		
        if (Ext.data.StoreManager.lookup('windowStateDetail') == null) {
            Ext.create('Ext.data.Store', {
                storeId : 'windowStateDetail',
                fields : [ 'ZoneID', 'dSID' ,'stateValue','type'],
                proxy : {
                    type : 'memory',
                    reader : {
                        type : 'json',
                        root : 'items'
                    }
                }                
            });
            
            
        } else 
        	Ext.data.StoreManager.lookup('windowStateDetail').removeAll();
        var oArray=[];
        for (var iIndex=0;iIndex<dss.staticDataModel.deviceCache.length;iIndex++) {
        	var oDevice=dss.staticDataModel.deviceCache[iIndex];
            if (this.filterFunc(oDevice)>0) {
            	oArray.push({ZoneID:dss.staticDataModel.getNameForZone(oDevice.ZoneID),dSID:oDevice.dSUID,stateValue:'ignore',type:this.filterFunc(oDevice)});
            }
        }
        oArray=oArray.sort(function (s1,s2) {
        	if (s1.ZoneID!=s2.ZoneID) {
        		if ((s1.ZoneID).toUpperCase()<(s2.ZoneID).toUpperCase())
        			return -1;
        		if ((s1.ZoneID).toUpperCase()>(s2.ZoneID).toUpperCase())
        			return 1;
        	}
        	var oDev1=dss.staticDataModel.getDevice(s1.dSID);
        	var oDev2=dss.staticDataModel.getDevice(s2.dSID);
    		if ((oDev1.name).toUpperCase()<(oDev2.name).toUpperCase())
    			return -1;
    		if ((oDev1.name).toUpperCase()>(oDev2.name).toUpperCase())
    			return 1;
    		return 0;
        });
        Ext.data.StoreManager.lookup('windowStateDetail').add(oArray);
        
	},
	constructor : function(config) {		
		var me=this;
    	this.initStores();
    	this.grid = Ext.create('Ext.grid.Panel', {
            height : 250,
            width : 740,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            store : Ext.data.StoreManager.lookup('windowStateDetail'),
            columns : [ {
                sortable : false,
                hideable : false,
                dataIndex : 'ZoneID',
                width : 150,
                header: _('Room')
            },{
                sortable : false,
                hideable : false,
                dataIndex : 'dSID',
                width: 250,
                header: _('Window/Door'),
                renderer : function(val, metadata, record, rowIdx, colIdx, store, view) {
                    var oDevice = dss.staticDataModel.getDevice(val);
                    var sString = '<table><tr><td style="padding-right:5px;"><img src="' + dss.staticDataModel.getImageForDevice(oDevice) + '"></td>';
                    sString += '<td>' + Ext.String.htmlEncode(oDevice.name) + '</td></tr></table>';                     
                    return sString;        	

                }
            },{
                sortable : false,
                hideable : false,
                dataIndex : 'stateValue',
                flex : 1,
                xtype: 'statecolumn',
                header: _('Set state when window is')
            } ]
        });
		
        Ext.apply(this, {
        	border: 0,
  			items : [Ext.create('Ext.form.field.Display', {
                border : 0,
                height:18,
                value:_('Please select the window that are considered when setting this state'),
                width:770,
                margin: "7 0 10 5",
                style: {
                    fontSize: '11px'
                }
            }), this.grid ],
  			height: 300,
  			width:740,
  			layout: {
  				type: 'vbox'
  			}
  		});
  	
  		this.callParent(arguments);
	},
	reset : function() {
		this.initStores();
		this.grid.getEl().child('.x-panel-body').applyStyles('border: solid 1px #99e8bc;');
		for (var iIndex=0;iIndex<Ext.data.StoreManager.lookup('windowStateDetail').count();iIndex++) {
			var oRecord=Ext.data.StoreManager.lookup('windowStateDetail').getAt(iIndex);
			var dsid=oRecord.get('dSID');
			document.getElementById('state'+dsid+'_0').checked=true;
			if (document.getElementById('titled'+dsid)!=null) {
				document.getElementById('titled'+dsid).checked=false;
				document.getElementById('titled'+dsid).disabled='disabled';
				document.getElementById('text'+dsid).style='color:#aaaaaa;';
			}
		}
	},
	isValid : function() {
		if (this.isHidden())
			return true;
		if (this.getValue().length==0) {
			this.grid.getEl().child('.x-panel-body').applyStyles('border: solid 1px red');
			return false;
		} else {
			this.grid.getEl().child('.x-panel-body').applyStyles('border: solid 1px #99e8bc;');
			return true;
		}
		return (this.getValue().length>0);
	},
	setValue : function(oValue) {		
		this.reset();
		for (var jIndex=0;jIndex<oValue.length;jIndex++) {
			var dsid=oValue[jIndex].dsid;
			for (var iIndex=0;iIndex<Ext.data.StoreManager.lookup('windowStateDetail').count();iIndex++) {
				var oRecord=Ext.data.StoreManager.lookup('windowStateDetail').getAt(iIndex);
				if (oRecord.get('dSID')==dsid) {
					oRecord.set('stateValue',oValue[jIndex].state);
					oRecord.commit();
				}
			}	
		}
		this.grid.getView().refresh();
	},
	getValue : function() {
		var oArray=[];
		for (var iIndex=0;iIndex<Ext.data.StoreManager.lookup('windowStateDetail').count();iIndex++) {
			var oRecord=Ext.data.StoreManager.lookup('windowStateDetail').getAt(iIndex);
			var dsid=oRecord.get('dSID');
			if (document.getElementById('state'+dsid+'_1').checked) {
				if (document.getElementById('titled'+dsid)==null)
					oArray.push({dsid:dsid,state:'open'});
				else if (document.getElementById('titled'+dsid).checked) 
					oArray.push({dsid:dsid,state:'open-tilded'});
				else
					oArray.push({dsid:dsid,state:'open'});
			}
			if (document.getElementById('state'+dsid+'_2').checked) {
				if (document.getElementById('titled'+dsid)==null)
					oArray.push({dsid:dsid,state:'closed'});
				else if (document.getElementById('titled'+dsid).checked) 
					oArray.push({dsid:dsid,state:'closed-tilded'});
				else
					oArray.push({dsid:dsid,state:'closed'});
			}
		}
		return oArray;
	}
});
	